include("functions.lua");

Player = class.new();

function Player:constructor()
	self.address = nil;
	self.name = "Test Character";
	self.classname = "Mage";
	self.x = 0;
	self.y = 0;
	self.z = 0;
	self.hp = 100;
	self.maxhp = 100;
	self.angle = 0;
end

function Player:init()
	self.address = process.readPtr(getProc(), "uint", ADDRESSES.staticbase_char, ADDRESSES.charPtr_offset);
	assert(self.address, "Unable to read player address");

	self.x = process.read(getProc(), "float", self.address + ADDRESSES.pawnX_offset);
	self.y = process.read(getProc(), "float", self.address + ADDRESSES.pawnY_offset);
	self.z = process.read(getProc(), "float", self.address + ADDRESSES.pawnZ_offset);
	ncurses.print(logWin, sprintf("Player address changed: 0x%X\n", self.address));
end

function Player:update()
	if( self.address ) then
		self.x = process.read(getProc(), "float", self.address + ADDRESSES.pawnX_offset);
		self.y = process.read(getProc(), "float", self.address + ADDRESSES.pawnY_offset);
		self.z = process.read(getProc(), "float", self.address + ADDRESSES.pawnZ_offset);

		self.hp = process.read(getProc(), "int", self.address + ADDRESSES.pawnHP_offset);
		self.maxhp = process.read(getProc(), "int", self.address + ADDRESSES.pawnMaxHP_offset);
	end

end

function Player:setDirection(dir, diry)
	self.angle = dir;

	local Vec3 = 0
	if diry then
		Vec3 = math.sin(diry);
	else
		Vec3 = process.read(getProc(), "float", self.address + ADDRESSES.pawnDirYUVec_offset);
	end
	local hypotenuse = (1 - Vec3^2)^.5
	local Vec1 = math.cos(dir) * hypotenuse;
	local Vec2 = math.sin(dir) * hypotenuse;

	process.write(getProc(), "float", self.address + ADDRESSES.pawnDirXUVec_offset, Vec1);
	process.write(getProc(), "float", self.address + ADDRESSES.pawnDirZUVec_offset, Vec2);
	process.write(getProc(), "float", self.address + ADDRESSES.pawnDirYUVec_offset, Vec3);

end