include("state.lua");

Idle = class.new(State);

function Idle:constructor(timeToIdle)
	Idle.parent.constructor(self);
	timeToIdle = timeToIdle or 5;
	self.name = "Idle";
	self.timeToIdle = timeToIdle;

	ncurses.print(logWin, sprintf("Going idle for %d seconds...\n", timeToIdle));
	ncurses.refresh(logWin);
end

function Idle:update(dt)
	if( timer.deltaTime(timer.getNow(), self.initTime) > self.timeToIdle ) then
		ncurses.print(logWin, "Waking from idle.\n");
		ncurses.refresh(logWin);
		return false; -- All done!
	end

	return true; -- Guess we continue waiting...
end