include("state.lua");

Moveplayer = class.new(State);

function Moveplayer:constructor(x, z)
	Moveplayer.parent.constructor(self);
	self.name = "Move player";
	self.toX = x;
	self.toZ = z;
	self.moving = false;
	ncurses.print(logWin, sprintf("Moving to (%0.1f, %0.1f)\n", x, z));
	ncurses.refresh(logWin);
end


function Moveplayer:update(dt)
	-- Fake the players movement...
	local angle = math.atan2(self.toZ - player.z, self.toX - player.x);

	if( math.abs(angle - player.angle) > 0.05 ) then
		player:setDirection(angle);
	end

	if( not self.moving ) then
		keyboard.virtualHold(getWindow(), key.VK_W);
		self.moving = true;
	end

	if( math.distance(player.x, player.z, self.toX, self.toZ) < 25 ) then
		ncurses.print(logWin, sprintf("We arrived at (%0.1f, %0.1f)\n", player.x, player.z));
		ncurses.refresh(logWin);

		keyboard.virtualRelease(getWindow(), key.VK_W);
		self.moving = false;
		return false;
	end

	return true;
end